package fr.itsee.zelyx;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.content.res.AssetFileDescriptor;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.media.MediaPlayer;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
//import android.util.Log;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.SearchView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.google.zxing.integration.android.IntentIntegrator;
import com.google.zxing.integration.android.IntentResult;
import com.squareup.picasso.Picasso;


import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.StatusData;
import com.symbol.emdk.barcode.StatusData.ScannerStates;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.net.InetAddress;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;

/* ZEBRA */
public class ControleActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    //public class ControleActivity extends AppCompatActivity {

    public static Commande currentControle;
    public static List<Produit> currentListeAScanner;
    private final Object lock = new Object();
    List<Commande> listeControle = new ArrayList<>(3);
    List<List<Produit>> listeDeListeAScanner = new ArrayList<>(3);
    Button BarCodeCamera, controlerNouvelleCommande;
    static Button btnScannerValider;
    private RecyclerView recyclerView;
    private ProduitAdapterControle mAdapter;
    private TextView date, num, nom, qteTotal, textQteTotal;
    private int selectedTab = 1;
    private List<Produit> listeVide;
    private String code128;
    private LinearLayout finir;
    /* ZEBRA */
    //Partie Scanner
    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;
    private TextView textViewStatus = null;
    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13 = null;
    private CheckBox checkBoxCode39 = null;
    private CheckBox checkBoxCode128 = null;
    private Spinner spinnerScannerDevices = null;
    /* ZEBRA */
    private List<ScannerInfo> deviceList = null;
    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private int dataLength = 0;
    private String statusString = "";
    //SCANNER EN PERMANENCE (bSoftTriggerSelected = TRUE)
    private boolean bSoftTriggerSelected = false;
    //Par défaut pour appliquer
    private boolean bDecoderSettingsChanged = true;
    private boolean bExtScannerDisconnected = false;
    static Boolean filtreRechercheEnCours = false, synchronisationEnCours = true; //Synchro au lancement;
    private Boolean scanEnPermanence = false;

    private ImageView image_produit_full;

    private TextView messageFixe;

    public static SearchView searchBarProduitCommande;
    public static Commande currentControleFiltre;

    private List<Commande> resultatRecherche;
    private LinearLayout barIntituleChamps;

    public static ImageView activerToujoursScanner, reloadScanner;

    public LinearLayout synchronisation_en_cours;

    private Button btnChoisirControle;

    private TextView initialesVendeur, codeBoutique;

    private Integer afficheLogsScanner = 0;

    //Son
    private MediaPlayer mediaPlayer;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_controle);

        reloadScanner = findViewById(R.id.reloadScanner);
        activerToujoursScanner = findViewById(R.id.activerToujoursScanner);

        synchronisation_en_cours = findViewById(R.id.synchronisation_en_cours);


        if(!isOnline()) {
            Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
            startActivity(intent);
            overridePendingTransition(0, 0);
        }

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }
        finir = findViewById(R.id.finir);
        messageFixe = findViewById(R.id.messageFixe);
        barIntituleChamps = findViewById(R.id.barIntituleChamps);
        if (currentControle != null) {
            barIntituleChamps.setVisibility(View.VISIBLE);
            messageFixe.setVisibility(View.GONE);
        } else {
            barIntituleChamps.setVisibility(View.INVISIBLE);
        }
        date = findViewById(R.id.date);
        num = findViewById(R.id.num);
        nom = findViewById(R.id.nom);
        qteTotal = findViewById(R.id.qteTotal);

        BarCodeCamera = findViewById(R.id.btnScanner);
        controlerNouvelleCommande = findViewById(R.id.controlerNouvelleCommande);

        initialesVendeur = findViewById(R.id.initialesVendeur);
        initialesVendeur.setText(MainActivity.initiales_vendeur);

        initialesVendeur.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    afficherLogsScanner();
                }
            }
        });
        recyclerView = findViewById(R.id.recycler_view);
        textViewStatus = findViewById(R.id.textViewStatus);
        spinnerScannerDevices = findViewById(R.id.spinnerScannerDevices);
        image_produit_full = findViewById(R.id.image_produit_full);
        searchBarProduitCommande = findViewById(R.id.bar_de_recherche_commande);

        btnChoisirControle = findViewById(R.id.btnChoisir);
        btnScannerValider = findViewById(R.id.btnScannerValider);
        codeBoutique = findViewById(R.id.codeBoutique);
        codeBoutique.setText(MainActivity.code_boutique);

        mAdapter = new ProduitAdapterControle(new ArrayList<Produit>(), getApplicationContext());

        listeControle.add(null);
        listeControle.add(null);
        listeControle.add(null);

        listeVide = new ArrayList<>();

        listeDeListeAScanner.add(listeVide);
        listeDeListeAScanner.add(listeVide);
        listeDeListeAScanner.add(listeVide);

        //Permet de récupérer le backup de la vérification en cours
        getListeControles();
        getListeDeListeAScanner();

        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);

        currentControle = listeControle.get(selectedTab - 1);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);

        if (currentControle == null) {
            searchBarProduitCommande.setVisibility(View.INVISIBLE);
            afficheVide();
        } else {
            mAdapter.setListeProduit(currentListeAScanner);
            recyclerView.setAdapter(mAdapter);
            searchBarProduitCommande.setVisibility(View.VISIBLE);
            afficheControle();
        }

        activerToujoursScanner.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    if (scanEnPermanence) {
                        scanEnPermanence = false;
                        activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner_manuel);
                    } else {
                        scanEnPermanence = true;
                        activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner);
                    }
                    try {
                        if (scanner.isReadPending()) {
                            scanner.cancelRead();
                        }

                        if (!scanEnPermanence)
                            scanner.triggerType = TriggerType.SOFT_ONCE;
                        else
                            scanner.triggerType = TriggerType.SOFT_ALWAYS;

                        scanner.read();
                        //Fermer le clavier
                        hideKeyboard(ControleActivity.this);
                    } catch (ScannerException e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        reloadScanner.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    image_produit_full.setVisibility(View.GONE);
                    messageFixe.setVisibility(View.GONE);
                    messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
                    messageFixe.setText("");
                    activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner_manuel);

                    // The application is in foreground
                    if (emdkManager != null) {
                        // Acquire the barcode manager resources
                        initBarcodeManager();
                        // Enumerate scanner devices
                        enumerateScannerDevices();
                        // Set selected scanner
                        spinnerScannerDevices.setSelection(scannerIndex);
                        // Initialize scanner
                        initScanner();

                        scanEnPermanence = false;
                        scanner.triggerType = TriggerType.SOFT_ONCE;

                        try {
                            scanner.read();
                        } catch (Exception e) {

                        }
                    }
                    //Fermer le clavier
                    hideKeyboard(ControleActivity.this);
                }
            }
        });

        btnChoisirControle.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    DialogControleActivityListCommandes.show(ControleActivity.this, 0);
                }
            }
        });

        searchBarProduitCommande.clearFocus();

        searchBarProduitCommande.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                searchBarProduitCommande.clearFocus();
                faireRecherche(searchBarProduitCommande.getQuery().toString());
                if (!searchBarProduitCommande.getQuery().toString().isEmpty()) {
                    filtreRechercheEnCours = true;
                    mAdapter.setListeProduit(currentControleFiltre.getListeProduit());
                } else {
                    filtreRechercheEnCours = false;
                    mAdapter.setListeProduit(currentControle.getListeProduit());
                }
                if (s.isEmpty()) {
                    filtreRechercheEnCours = false;
                    mAdapter.setListeProduit(currentControleFiltre.getListeProduit());
                }
                mAdapter.notifyDataSetChanged();
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                if (searchBarProduitCommande != null && currentListeAScanner != null && searchBarProduitCommande.getQuery().toString() != "" && currentControle.getListeProduit() != null) {
                    filtreRechercheEnCours = true;
                    faireRecherche(searchBarProduitCommande.getQuery().toString());
                    mAdapter.setListeProduit(currentControleFiltre.getListeProduit());
                } else {
                    filtreRechercheEnCours = false;
                    mAdapter.setListeProduit(currentControle.getListeProduit()); //Remise à 0 si pas de recherche
                    searchBarProduitCommande.setVisibility(View.VISIBLE);
                    afficheControle();
                }
                if (s.isEmpty()) {
                    filtreRechercheEnCours = false;
                    mAdapter.setListeProduit(currentControle.getListeProduit());
                }

                mAdapter.notifyDataSetChanged();
                return false;
            }
        });

        mAdapter.setOnItemClickListener(new ProduitAdapterControle.OnItemClickListener() {

            @Override
            public void onPhotoClick(int position, Drawable imageDrawable, String lien_image) {
                if (filtreRechercheEnCours == false) {
                    Picasso.with(getApplicationContext()).load(MainActivity.backOfficeURLIMG + lien_image.replace(".jpg", "_full.jpg")).placeholder(R.drawable.image_not_found).error(R.drawable.image_not_found).into(image_produit_full);
                    image_produit_full.setVisibility(View.VISIBLE);
                    image_produit_full.setEnabled(true);
                    image_produit_full.setAdjustViewBounds(true);
                } else {
                    //afficherToast("ENCOURS", "Recherche en cours...");
                }
            }
            public void onRetirerQuantiteClick(int position) {
                //Permet de ne pas modifier les quantité une fois la commande validée
                if (currentControle.getQtetotal() != currentControle.getQteTotalNbScanner()) {
                    if (filtreRechercheEnCours == false) {
                        if (currentListeAScanner.get(position).getNbrScanner() > 0) {
                            currentListeAScanner.get(position).setNbrScanner(currentListeAScanner.get(position).getNbrScanner() - 1);
                            mAdapter.notifyDataSetChanged();
                            if (messageFixe.getText().toString()=="Attention! Recherche en cours...") {
                                messageFixe.setText("");
                                messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
                                messageFixe.setVisibility(View.GONE);
                            }
                        }
                    } else {
                        messageFixe.setText("Attention! Recherche en cours...");
                        messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                        messageFixe.setVisibility(View.VISIBLE);
                        // afficherToast("ENCOURS", "Recherche en cours...");
                    }
                }
                if (isAllScanned() && currentListeAScanner.size() != 0) {
                    final Dialog myDialog = new Dialog(ControleActivity.this);
                    myDialog.setContentView(R.layout.popup_ok);

                    Button b = myDialog.findViewById(R.id.txt);
                    b.setText("OK");
                    b.setBackground(getDrawable(R.drawable.rounded_corner));
                    b.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            myDialog.dismiss();

                        }
                    });
                    myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
                    myDialog.show();
                    messageFixe.setBackgroundColor(getColor(R.color.colorVert));
                    messageFixe.setText("Commande contrôlée!");
                    messageFixe.setVisibility(View.VISIBLE);
                    jouerSon("quantiteCorrecte.mp3");
                    try {
                        new UpdateControleeCommandeAsyncTask().execute();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        });

        //permet de refermer la photo produit
        image_produit_full.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                image_produit_full.setImageDrawable(null);
                image_produit_full.setVisibility(View.INVISIBLE);
                image_produit_full.setEnabled(false);
                image_produit_full.setAdjustViewBounds(false);
            }
        });

        btnScannerValider.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    //if (isOnline()) {
                    if (currentListeAScanner != null) {
                        new AlertDialog.Builder(ControleActivity.this)
                                .setIcon(android.R.drawable.ic_dialog_alert)
                                .setTitle("Confirmation")
                                .setMessage("Etes-vous sûr de vouloir valider ce contrôle?")
                                .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        for (Produit p : currentListeAScanner) {
                                            //Attribue la quantité total en qyantité scannée
                                            p.setNbrScanner(p.getQte());
                                            mAdapter.notifyDataSetChanged();
                                        }
                                        final Dialog myDialog = new Dialog(ControleActivity.this);
                                        myDialog.setContentView(R.layout.popup_ok);

                                        Button b = myDialog.findViewById(R.id.txt);
                                        b.setText("OK");
                                        b.setBackground(getDrawable(R.drawable.rounded_corner));
                                        b.setOnClickListener(new View.OnClickListener() {
                                            @Override
                                            public void onClick(View view) {
                                                myDialog.dismiss();

                                            }
                                        });
                                        myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
                                        myDialog.show();
                                        messageFixe.setBackgroundColor(getColor(R.color.colorVert));
                                        messageFixe.setText("Commande contrôlée!");
                                        messageFixe.setVisibility(View.VISIBLE);
                                        jouerSon("quantiteCorrecte.mp3");
                                        try {
                                            new ControleActivity.UpdateControleeCommandeAsyncTask().execute();
                                        } catch (Exception e) {
                                            e.printStackTrace();
                                        }
                                    }
                                })
                                .setNegativeButton("Non", null)
                                .show();
                    }
                /*} else {
                    Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                    startActivity(intent);
                    this.overridePendingTransition(0, 0);
                }*/
                }
            }
        });

        /* NON ZEBRA */
        //Scan camera
        final Activity activity = this;
        final Collection<String> PRODUCT_CODE_128 = Arrays.asList("CODE_128");
        BarCodeCamera.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    //if (isOnline()) {
                    IntentIntegrator intentIntegrator = new IntentIntegrator(activity);
                    //intentIntegrator.setDesiredBarcodeFormats(intentIntegrator.ALL_CODE_TYPES);
                    intentIntegrator.setDesiredBarcodeFormats(PRODUCT_CODE_128);
                    intentIntegrator.setBeepEnabled(false);
                    intentIntegrator.setCameraId(0);
                    intentIntegrator.setPrompt("SCANNER LA COMMANDE A CONTROLER");
                    intentIntegrator.setBarcodeImageEnabled(false);
                    intentIntegrator.initiateScan();
                /*} else {
                    Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                    startActivity(intent);
                    this.overridePendingTransition(0, 0);
                }*/
                }
            }
        });

        controlerNouvelleCommande.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!synchronisationEnCours) {
                    //Créer nouveau contrôle
                    //Passer le scanner en manuel ici
                    if (scanner != null) {
                        if (scanner.isReadPending()) {
                            try {
                                scanner.cancelRead();
                            } catch (ScannerException e) {
                                e.printStackTrace();
                            }
                        }

                        scanEnPermanence = false;
                        scanner.triggerType = TriggerType.HARD;//SOFT_ONCE
                        bSoftTriggerSelected = false; //Permet de passer au mode manuel

                        ScannerConfig config = null;
                        try {
                            config = scanner.getConfig();
                        } catch (ScannerException e) {
                            e.printStackTrace();
                        }
                        config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.CONTINUOUS_READ;
                        //config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.TRIGGER;
                        config.readerParams.readerSpecific.imagerSpecific.sameSymbolTimeout = 3000;
                        config.readerParams.readerSpecific.imagerSpecific.differentSymbolTimeout = 1500;
                        try {
                            scanner.setConfig(config);
                        } catch (ScannerException e) {
                            e.printStackTrace();
                        }
                    }
                    // The application is in foreground
                    if (emdkManager != null) {
                        // Acquire the barcode manager resources
                        initBarcodeManager();
                        // Enumerate scanner devices
                        enumerateScannerDevices();
                        // Set selected scanner
                        spinnerScannerDevices.setSelection(scannerIndex);
                        // Initialize scanner
                        initScanner();
                    }
                    //Fermer le clavier
                    hideKeyboard(ControleActivity.this);

                    messageFixe.setVisibility(View.GONE);
                    currentControle = null;
                    listeControle.set(selectedTab - 1, null);
                    listeDeListeAScanner.set(selectedTab - 1, listeVide);
                    currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);
                    mAdapter.setListeProduit(currentListeAScanner);
                    afficheVide();
                }
            }
        });


        //Dans le cas ou la commande est déjà complète au chargement de la page
        if (currentControle != null && currentControle.getQteTotalNbScanner() == currentControle.getQtetotal()) {
            messageFixe.setBackgroundColor(getColor(R.color.colorVert));
            messageFixe.setText("Commande contrôlée!");
            messageFixe.setVisibility(View.VISIBLE);
        } else if (messageFixe.getText().toString() == "Commande contrôlée") {
            messageFixe.setVisibility(View.GONE);
        }

        /* ZEBRA */
        deviceList = new ArrayList<ScannerInfo>();
        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object non initialisé!");
            //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
            messageFixe.setText("Impossible d'initialiser le scanner!" + "\n" + "Veuillez redémarrer l'application!");
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setVisibility(View.VISIBLE);
            return;
        }
        addSpinnerScannerDevicesListener();
        //Initialisation du scanner ZEBRA
        bSoftTriggerSelected = false;
        bExtScannerDisconnected = false;
        deInitScanner();
        initScanner();
        setDecoders();
        // Set default scanner IMPORTANT PERMET D'INITIALISER LE SCANNER
        spinnerScannerDevices.setSelection(defaultIndex);

        //Réinitialiser le scanner après 6 secondes
        Handler handler = new Handler();
        handler.postDelayed(new Runnable() {
            @Override
            public void run() {
                messageFixe.setText("");
                messageFixe.setVisibility(View.GONE);
                // The application is in foreground
                if (emdkManager != null) {
                    // Acquire the barcode manager resources
                    initBarcodeManager();
                    // Enumerate scanner devices
                    enumerateScannerDevices();
                    // Set selected scanner
                    spinnerScannerDevices.setSelection(scannerIndex);
                    // Initialize scanner
                    initScanner();
                    //Applique les paramètres au scanner
                    setDecoders();
                }

                //Fermer le clavier
                hideKeyboard(ControleActivity.this);

                synchronisation_en_cours.setVisibility(View.GONE);
                synchronisationEnCours = false;

            }
        }, 6000);
    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {

        IntentResult Result = IntentIntegrator.parseActivityResult(requestCode, resultCode, data);
        if (Result != null) {
            if (Result.getContents() == null) {
                Toast.makeText(this, "annulé", Toast.LENGTH_SHORT).show();
            } else {
                //if (isOnline()) {
                updateData(Result.getContents());
                /*} else {
                    Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                    startActivity(intent);
                    this.overridePendingTransition(0, 0);
                }*/
            }
        } else {
            super.onActivityResult(requestCode, resultCode, data);
        }
    }

    @Override
    protected void onStop() {
        super.onStop();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();
        saveListeControles();

        if (mediaPlayer != null) {
            mediaPlayer.release();
        }
    }

    public void saveListeControles() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeControle", gson.toJson(listeControle)).apply();
    }

    public void getListeControles() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeControle", null);

        if (json != null) {
            listeControle = gson.fromJson(json, new TypeToken<List<Commande>>() {
            }.getType());
        }
    }

    public void saveListeDeListeAScanner() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeDeListeAScanner", gson.toJson(listeDeListeAScanner)).apply();
    }

    public void getListeDeListeAScanner() {
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeDeListeAScanner", null);

        if (json != null) {
            listeDeListeAScanner = gson.fromJson(json, new TypeToken<List<List<Produit>>>() {
            }.getType());
        }
    }

    public void afficheControle() {
        btnScannerValider = findViewById(R.id.btnScannerValider);
        BarCodeCamera = findViewById(R.id.btnScanner);
        btnScannerValider.setVisibility(View.VISIBLE);
        BarCodeCamera.setVisibility(View.GONE);

        currentControle = listeControle.get(0);
        currentListeAScanner = listeDeListeAScanner.get(0);
        if (currentControle != null) {
            barIntituleChamps.setVisibility(View.VISIBLE);
            date.setText("Date: " + new SimpleDateFormat("dd-MM-yyyy", Locale.getDefault()).format(new Date()));
            num.setText("Cmd n°" + currentControle.getNum());
            if (currentControle.getNomClient() != null || currentControle.getNomClient() !="") {
                nom.setText(currentControle.getNomClient());
            } else {
                nom.setText("Invité");
            }
            //textQteTotal.setText("Total pièces:");
            qteTotal.setText(currentControle.getQteTotalNbScanner()+" / "+currentControle.getQtetotal());
            mAdapter.setListeProduit(currentListeAScanner);
            mAdapter.notifyDataSetChanged();
            recyclerView.setVisibility(View.VISIBLE);
            btnScannerValider.setVisibility(View.VISIBLE);
        } else {
            barIntituleChamps.setVisibility(View.INVISIBLE);
        }
    }

    public void afficheVide() {
        btnScannerValider = findViewById(R.id.btnScannerValider);
        btnScannerValider.setVisibility(View.GONE);
        if (messageFixe.getText().toString() != "Cette commande a déjà été contrôlée") {
            messageFixe.setText("Scannez un numéro de commande pour commmencer");
            messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
            messageFixe.setVisibility(View.VISIBLE);
        }
        date.setText("");
        num.setText("");
        nom.setText("");
        qteTotal.setText("");
//        textQteTotal.setText("");
        listeControle.set(selectedTab - 1, null);
        currentControle = listeControle.get(selectedTab - 1);
        mAdapter.notifyDataSetChanged();
        recyclerView.setVisibility(View.INVISIBLE);
        messageFixe.setText("Scannez un numéro de commande pour commmencer");
        messageFixe.setVisibility(View.VISIBLE);
    }

    /* ZEBRA */
    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK ouvert avec succès!");
        this.emdkManager = emdkManager;
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            initScanner();
            setDecoders();
            // Set default scanner
            spinnerScannerDevices.setSelection(defaultIndex);
        }
    }

    @Override
    protected void onResume() {
        super.onResume();

        //Désactiver le scanner toujours en scan
        scanEnPermanence = false;
        activerToujoursScanner.setBackgroundResource(R.drawable.barcode_scanner_manuel);
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (Exception e) {

                }
            }
        }

        if(!isOnline()) {
            Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
            startActivity(intent);
            this.overridePendingTransition(0, 0);
        }

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        /* ZEBRA */


        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
            setDecoders();
        }

        //Dans le cas ou la commande est déjà complète au chargement de la page
        if (currentControle != null && currentControle.getQteTotalNbScanner() == currentControle.getQtetotal()) {
            messageFixe.setBackgroundColor(getColor(R.color.colorVert));
            messageFixe.setText("Commande contrôlée!");
            messageFixe.setVisibility(View.VISIBLE);
        } else {
            /*if (messageFixe.getText().toString() == "Commande contrôlée!") {
                messageFixe.setVisibility(View.GONE);
            } else {
                messageFixe.setText("");
                messageFixe.setVisibility(View.GONE);//???
            }*/
            messageFixe.setVisibility(View.GONE);
        }

        if (currentControle != null) {
            if (currentControle.getNomClient() != null || currentControle.getNomClient() != "") {
                nom.setText(currentControle.getNomClient());
            } else {
                nom.setText("Invité");
            }
        }

    }

    /* ZEBRA */

    @Override
    protected void onPause() {
        super.onPause();
        this.overridePendingTransition(0, 0);
        /* ZEBRA */

        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();

    }

    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("Veuillez réinitialiser le scanner pour continuer!");
        //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
        //if (currentControle != null) {
            messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
            messageFixe.setText("Veuillez réinitialiser le scanner pour continuer!");
            messageFixe.setVisibility(View.VISIBLE);
        //}
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeControles();
        saveListeDeListeAScanner();
//         Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList<ScanDataCollection.ScanData> scanData = scanDataCollection.getScanData();
            for (ScanDataCollection.ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    public void onStatus(StatusData statusData) {
        ScannerStates state = statusData.getState();
        switch (state) {
            case IDLE:
                statusString = statusData.getFriendlyName() + " est prêt...";
                updateStatus(statusString);
                // set trigger type
                if (bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false; //Permet de passer au mode manuel
                } else {
                    if (scanEnPermanence) {
                        scanner.triggerType = TriggerType.SOFT_ALWAYS;
                    } else {
                        scanner.triggerType = TriggerType.HARD;
                    }
                }
                // set decoders
                if (bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if (!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        if (scanEnPermanence) {
                            try {
                                Thread.sleep(1000); //Un temps d'attente de 1 seconde entre chaque scan
                            } catch (InterruptedException e) {
                                e.printStackTrace();
                            }
                        }
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                        //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
                    }
                }
                break;
            case WAITING:
                statusString = "Le lecteur de codes-barres est prêt pour utilisation!";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Acquisition en cours...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName() + " est indisponible.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "Une erreur s'est produite.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch (connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        setDecoders();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        } else {
            bExtScannerDisconnected = false;
            status = statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }
    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null) {
                    try {
                        scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
                    } catch (Exception e) {

                    }
                    //synchronisation_en_cours = findViewById(R.id.synchronisation_en_cours);
                    //synchronisation_en_cours.setVisibility(View.GONE);
                }
            } else {
                //reloadScanner = findViewById(R.id.reloadScanner);
                //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Veuillez réinitialiser le scanner pour continuer!");
                messageFixe.setVisibility(View.VISIBLE);
                return;
            }
        } else if (scanner != null) {
            scanner.addDataListener(this);
            scanner.addStatusListener(this);
            try {
                scanner.enable();
                //synchronisation_en_cours = findViewById(R.id.synchronisation_en_cours);
                //synchronisation_en_cours.setVisibility(View.GONE);
                reloadScanner = findViewById(R.id.reloadScanner);
                reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload);
                if (!bSoftTriggerSelected)
                    scanner.triggerType = TriggerType.HARD;
                else
                    scanner.triggerType = TriggerType.SOFT_ALWAYS;
            } catch (ScannerException e) {
                //reloadScanner = findViewById(R.id.reloadScanner);
                //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
                updateStatus(e.getMessage());
                deInitScanner();
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Veuillez réinitialiser le scanner pour continuer!");
                messageFixe.setVisibility(View.VISIBLE);
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try {
                scanner.disable();
                //reloadScanner = findViewById(R.id.reloadScanner);
                //reloadScanner.setBackgroundResource(R.drawable.barcode_scanner_reload_inactif);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }
    private void initBarcodeManager() {
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        // Add connection listener
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager() {
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }
    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner == null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                    setDecoders();
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }
    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while (it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if (scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(ControleActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }
    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();

                try {
                    //PASSER LA FREQUENCE A 10000MS (1 seconde) PAR SCAN
                    config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.CONTINUOUS_READ;
                    //config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.TRIGGER;
                    config.readerParams.readerSpecific.imagerSpecific.sameSymbolTimeout = 3000;
                    config.readerParams.readerSpecific.imagerSpecific.differentSymbolTimeout = 1500;


                    //DESACTIVE LE SON DU BEEP PAR DEFAUT
                    //config.scanParams.decodeAudioFeedbackUri = "content://fr.itsee.zelyx.assets/silence.mp3";
                    config.scanParams.decodeAudioFeedbackMode = ScannerConfig.DecodeAudioFeedbackMode.DISABLE;
                    config.scanParams.decodeHapticFeedback = false;
                    config.scanParams.decodeAudioFeedbackUri = "";

                    //AFFICHE LED QUAND SCAN
                    config.scanParams.decodeLEDFeedbackMode = ScannerConfig.DecodeLEDFeedbackMode.LOCAL;
                    config.scanParams.decodeLEDFeedback = true;

                    //AUTORISE QUE LES CODES 128
                    config.decoderParams.ean8.enabled = false;
                    config.decoderParams.ean13.enabled = false;
                    config.decoderParams.code39.enabled = false;
                    config.decoderParams.code128.enabled = true;
                    //APPLIQUER LES PARAMETRES
                    scanner.setConfig(config);
                } catch (Exception e) {
                }

            } catch (ScannerException e) {
                updateStatus(e.getMessage());
                messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                messageFixe.setText("Veuillez redémarrer votre zebra\nlecteur code128 indisponible!");
                messageFixe.setVisibility(View.VISIBLE);
            }
        }
    }

    private void cancelRead() {
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }
    private void updateStatus(final String status) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    private void updateData(final String result) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    //if (isOnline()) {
                    if (currentControle == null) {
                        code128 = result;
                        try {
                            if (code128.length() == 9) {
                                new GetCommandeAsyncTask().execute();
                                //Passer le scanner en manuel lors de la création d'un nouveau contrôle
                                /*if (scanner != null) {
                                    if (scanner.isReadPending()) {
                                        scanner.cancelRead();
                                    }
                                    ScannerConfig config = scanner.getConfig();
                                    config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.CONTINUOUS_READ;
                                    //config.readerParams.readerSpecific.imagerSpecific.aimType = ScannerConfig.AimType.TRIGGER;
                                    config.readerParams.readerSpecific.imagerSpecific.sameSymbolTimeout = 1000;
                                    config.readerParams.readerSpecific.imagerSpecific.differentSymbolTimeout = 1000;
                                    scanner.setConfig(config);
                                }*/
                            } else {
                                afficherToast("KO","Veuillez scanner un numéro de commande pour commencer!");
                            }
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    } else {
                        try {
                            Thread.sleep(1000); //Un temps d'attente de 1 seconde entre chaque scan
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                        produitScanner(result);
                    }
                }
            }
        });
    }

    public int getProduitPos(String result) {
        int cpt = 0;
        if (currentControle != null) {
            for (Produit p : currentListeAScanner) {
                if (p.getCode128().equals(result)) {
                    return cpt;
                }
                cpt += 1;
            }
        }
        return cpt;
    }

    public void vider() {
        for (int i = 0; i < currentListeAScanner.size(); i++) {
            recyclerView.findViewHolderForAdapterPosition(i).itemView.setBackgroundColor(Color.WHITE);
        }
        currentControle = null;
        listeControle.set(selectedTab - 1, null);
        listeDeListeAScanner.set(selectedTab - 1, listeVide);
        currentListeAScanner = listeDeListeAScanner.get(selectedTab - 1);
        mAdapter.setListeProduit(currentListeAScanner);
        afficheVide();
    }

    public void newControle(View v) {
        if (!synchronisationEnCours) {
            if (isAllScanned()) {
                vider();
                searchBarProduitCommande.setVisibility(View.INVISIBLE);
            } else {
                final Activity activity = this;
                final Collection<String> PRODUCT_CODE_128 = Arrays.asList("CODE_128");
                BarCodeCamera.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View v) {
                        if (!synchronisationEnCours) {
                            //if (isOnline()) {
                            IntentIntegrator intentIntegrator = new IntentIntegrator(activity);
                            //intentIntegrator.setDesiredBarcodeFormats(intentIntegrator.ALL_CODE_TYPES);
                            intentIntegrator.setDesiredBarcodeFormats(PRODUCT_CODE_128);
                            intentIntegrator.setBeepEnabled(false);
                            intentIntegrator.setCameraId(0);
                            intentIntegrator.setPrompt("SCANNER L'ARTICLE");
                            intentIntegrator.setBarcodeImageEnabled(false);
                            intentIntegrator.initiateScan();
                    /*} else {
                        Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                        startActivity(intent);
                        this.overridePendingTransition(0, 0);
                    }*/
                        }
                    }
                });
                DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        switch (which) {
                            case DialogInterface.BUTTON_POSITIVE:
                                //No button clicked
                                dialog.dismiss();
                                break;

                            case DialogInterface.BUTTON_NEGATIVE:
                                //Yes button clicked
                                dialog.dismiss();
                                vider();
                                break;
                        }
                    }
                };

                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setMessage("Tout les articles n'ont pas été scanné, voulez-vous vraiment quitter ?");
                builder.setNegativeButton("OUI", dialogClickListener);
                builder.setPositiveButton("NON", dialogClickListener);
                builder.show();
            }
        }
    }


    public void produitScanner(String code128) {
        int i = getProduitPos(code128);
        int max = currentListeAScanner.size();
        if (i < max) {
            Produit p = currentListeAScanner.get(i);
            if (p.getNbrScanner() < p.getQte()) {
                p.setNbrScanner(p.getNbrScanner() + 1);
                recyclerView.getLayoutManager().scrollToPosition(i);
                if (isAllScanned() && currentListeAScanner.size() != 0) {
                    final Dialog myDialog = new Dialog(this);
                    myDialog.setContentView(R.layout.popup_ok);
                    Button b = myDialog.findViewById(R.id.txt);
                    b.setText("OK");
                    b.setBackground(getDrawable(R.drawable.rounded_corner));
                    b.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            myDialog.dismiss();
                        }
                    });
                    myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
                    myDialog.show();
                    messageFixe.setBackgroundColor(getColor(R.color.colorVert));
                    messageFixe.setText("Commande contrôlée!");
                    messageFixe.setVisibility(View.VISIBLE);
                    jouerSon("quantiteCorrecte.mp3");
                    try {
                        new UpdateControleeCommandeAsyncTask().execute();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                } else {
                    jouerSon("ajoutProduit.mp3");
                }
            } else if (p.getNbrScanner() >= p.getQte()) {
                afficherToast("KO", "La quantité de cet article n'est présent que "+p.getQte()+" fois");
            }
            searchBarProduitCommande.setVisibility(View.VISIBLE);
            afficheControle();
        } else {
            afficherToast("NEXISTEPAS", "Cet article n'est pas présent dans cette commande!");
        }
    }

    public boolean isAllScanned() {
        int cptScanner = 0;
        int cptTot = 0;
        if (currentListeAScanner != null) {
            for (Produit p : currentListeAScanner) {
                cptScanner += p.getNbrScanner();
                cptTot += p.getQte();
            }
        }
        return cptTot == cptScanner;
    }

    /* ZEBRA */
    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }


    //BASE DE DONNES

    @Override
    protected void onRestart() {
        super.onRestart();
    }

    //Masquer le clavier quand on appuie en dehors du champ
    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        if (getCurrentFocus() != null) {
            InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
        }
        return super.dispatchTouchEvent(ev);
    }

    private class GetCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;
        private Boolean dejaFaite = false;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            afficherToast("ENCOURS", "Récupération de la commande en cours...");
            messageFixe.setText("Récupération de la commande en cours...");
            messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
            messageFixe.setVisibility(View.VISIBLE);
        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("numero_commande", ""+code128);

            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getCommande.php", "GET", httpParams);
            try {
                int success = jsonObject.getInt("success");

                if (success == 1) {
                    JSONObject commande = jsonObject.getJSONArray("data").getJSONObject(0);
                    if (commande.getInt("complete") == 2) {
                        dejaFaite = true;
                        return "Cette commande à déjà été contrôlée!";
                    }
                    else {
                        currentControle = new Commande();
                        currentControle.setNum(commande.getString("numero_commande"));
                        currentControle.setNomClient(commande.getString("nom_client"));
                        currentControle.setDate(commande.getString("date_commande"));
                        currentControle.setQtetotal(0);
                        currentControle.setPrixTotal(0);
                        currentControle.setNomTransporteur(commande.getString("mode_livraison"));


                        //recuperation des articles de la commande
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("num_commande", ""+code128);
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "listeProduitsCommande.php", "GET", httpParams2);

                        List<Produit> produitList = new ArrayList<>();

                        try {
                            int success2 = jsonObject2.getInt("success");
                            JSONArray produits;
                            if (success2 == 1) {
                                produits = jsonObject2.getJSONArray("data");
                                //Iterate through the response and populate produits list
                                for (int i = 0; i < produits.length(); i++) {
                                    Produit p = new Produit();
                                    JSONObject produit = produits.getJSONObject(i);

                                    try {
                                        p.setRef(produit.getString("reference"));
                                        p.setColoris(produit.getString("coloris"));
                                        p.setCommandable(produit.getString("commandable"));
                                        p.setCode128(produit.getString("code_128"));
                                        p.setQuantite_pack(produit.getInt("quantite_packs"));
                                        p.setPrix(produit.getDouble("prix"));
                                        p.setStock(produit.getInt("stock"));
                                        p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                        p.setInformations(produit.getString("informations"));
                                        p.setLien_image(produit.getString("lien_image"));
                                        p.setActif(produit.getInt("actif"));
                                        p.setQte(produit.getInt("quantite"));
                                        p.setNbrScanner(0);
                                        produitList.add(p);
                                    } catch (Exception e) {
                                        e.printStackTrace();
                                    }
                                }
                                try {
                                    currentControle.setListeProduit(produitList);
                                    listeControle.set(selectedTab - 1, currentControle);

                                    Collections.sort(currentControle.getListeProduit());
                                    listeDeListeAScanner.set(selectedTab - 1, currentControle.getListeProduit());

                                } catch (Exception e) {
                                    e.printStackTrace();
                                }

                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (currentControle == null) {
                if (dejaFaite == true) {
                    jouerSon("notification.mp3");
                    AlertDialog.Builder alertDialog = new AlertDialog.Builder(ControleActivity.this);
                    alertDialog.setTitle("Contrôle");
                    alertDialog.setMessage("Cette commande a déjà été contrôlée!");
                    alertDialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            dialog.dismiss();
                        }
                    });
                    alertDialog.show();
                }
                searchBarProduitCommande.setVisibility(View.VISIBLE);
                afficheControle();
                //afficheVide();
            } else {
                if (currentControle.getListeProduit().size() == 0) {
                    messageFixe.setBackgroundColor(getColor(R.color.colorRouge));
                    messageFixe.setText("Cette commande ne dispose pas d'articles!");
                    messageFixe.setVisibility(View.VISIBLE);
                } else {
                    messageFixe.setBackgroundColor(getColor(R.color.colorOrange));
                    messageFixe.setText("");
                    messageFixe.setVisibility(View.GONE);
                }
                searchBarProduitCommande.setVisibility(View.VISIBLE);
                afficheControle();
            }
        }
    }

    private class UpdateControleeCommandeAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("numero_commande", ""+currentControle.getNum());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "updateControleeCommande.php", "POST", httpParams2);
            try {
                success = jsonObject2.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }
    }

    public void fermerControleActivity(View v){
        if (!synchronisationEnCours) {
            new AlertDialog.Builder(ControleActivity.this)
                    .setIcon(android.R.drawable.ic_dialog_alert)
                    .setTitle("Confirmation")
                    .setMessage("Etes-vous sûr de vouloir fermer les contrôles?")
                    .setPositiveButton("Oui", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            scanEnPermanence = false;
                            bSoftTriggerSelected = false;
                            if (scanner != null) {
                                scanner.triggerType = TriggerType.HARD;
                            }
                            //Fermer le clavier
                            hideKeyboard(ControleActivity.this);

                        /*InputMethodManager imm = (InputMethodManager) ControleActivity.this.getSystemService(Context.INPUT_METHOD_SERVICE);
                        //imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
                        imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 1);*/
                            // The application is in background
                            // Release the barcode manager resources
                            deInitScanner();
                            deInitBarcodeManager();
                            Intent returnIntent = new Intent();
                            setResult(Activity.RESULT_OK, returnIntent);
                            finish();
                        }
                    })
                    .setNegativeButton("Non", null)
                    .show();
        }
    }

    public void faireRecherche(String valeur) {
        resultatRecherche = new ArrayList<>();
        if (!ControleActivity.currentControle.getListeProduit().isEmpty()) {
            Commande currentControleFiltre = new Commande();
            if (valeur.toLowerCase() != "") {
                for (Produit p : ControleActivity.currentControle.getListeProduit()) {
                    //Recherche sur la référence, couleur, catégorie, informations (nom catégorie) et non code 128
                    if (!p.getCode128().isEmpty() && p.getCode128().toLowerCase().contains(valeur.toLowerCase())) {
                        currentControleFiltre.addProduit(p);
                    } else if (!p.getRef().isEmpty() && p.getRef().toLowerCase().contains(valeur.toLowerCase())) {
                        currentControleFiltre.addProduit(p);
                    } else if (!p.getColoris().isEmpty() && p.getColoris().toLowerCase().contains(valeur.toLowerCase())) {
                        currentControleFiltre.addProduit(p);
                    } else if (!p.getInformations().isEmpty() && p.getInformations().toLowerCase().contains(valeur.toLowerCase())) {
                        currentControleFiltre.addProduit(p);
                    }
                }
            } else {
                filtreRechercheEnCours = false;
            }
            if (currentControleFiltre.getQtetotal() == 0) {
                ControleActivity.currentControleFiltre = ControleActivity.currentControle; //Remise à 0 si pas trouvé
            } else {
                ControleActivity.currentControleFiltre = currentControleFiltre;
            }
        }
    }


    //Jouer un son en fonction d'un nom de fichier
    private void jouerSon(String filename) {
        mediaPlayer = new MediaPlayer();
        try {
            AssetFileDescriptor afd = null;
            afd = getResources().getAssets().openFd(filename);
            mediaPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
            mediaPlayer.prepareAsync();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        //Lancer en mode asynchrone pour continuer en permanence
        mediaPlayer.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
            public void onPrepared(MediaPlayer mp) {
                mp.start();
            }
        });
        //Release après lecture
        mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
            public void onCompletion(MediaPlayer mp) {
                if (mp != null) {
                    mp.release();
                }
            }
        });
    }

    private void afficherLogsScanner() {
        if (afficheLogsScanner == 1) {
            afficheLogsScanner = 0;
        } else {
            afficheLogsScanner = 1;
        }

        if (afficheLogsScanner == 1) {
            textViewStatus.setVisibility(View.VISIBLE);
        } else {
            textViewStatus.setVisibility(View.GONE);
        }
    }

    private void afficherToast(String typeToast, String message) {
        LayoutInflater inflater = getLayoutInflater();
        View layoutToast = inflater.inflate(R.layout.layout_custom_toast, null);
        TextView textViewToast = (TextView) layoutToast.findViewById(R.id.textViewToastMessage);
        layoutToast.setMinimumHeight(finir.getHeight()+50);
        layoutToast.setMinimumWidth(finir.getWidth());

        textViewToast.setText(message);
        if (typeToast == "KO") {
            //Jouer son notification
            jouerSon("notification.mp3");
            layoutToast.setBackgroundColor(getColor(R.color.colorRouge));
        } else if (typeToast == "OK") {
            layoutToast.setBackgroundColor(getColor(R.color.colorVert));
        } else if (typeToast == "ENCOURS") {
            layoutToast.setBackgroundColor(getColor(R.color.colorOrange));
        } else if (typeToast == "NEXISTEPAS") {
            //Jouer son notification
            jouerSon("erreurProduit.mp3");
            layoutToast.setBackgroundColor(getColor(R.color.colorRouge));
        }

        //if (typeToast != "ENCOURS") {
            Toast toast = new Toast(getApplicationContext());
            toast.setGravity(Gravity.BOTTOM, 0, 0);
            toast.setDuration(Toast.LENGTH_LONG);
            toast.setView(layoutToast);
            toast.show();
        //}
    }


    public static void hideKeyboard(Activity activity) {
        View view = activity.findViewById(android.R.id.content);
        if (view != null) {
            InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(view.getWindowToken(), 0);
        }
    }

    public static void showKeyboard(Activity activity) {
        InputMethodManager inputMethodManager = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
        inputMethodManager.toggleSoftInput(InputMethodManager.SHOW_FORCED, 0);
    }

}
