package fr.itsee.zelyx;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.TextView;

import static fr.itsee.zelyx.CommandesActivity.currentCommande;

import java.math.RoundingMode;
import java.text.DecimalFormat;

public class DialogCommandesActivityEditPrix {

    public static void show(final Activity activity, final int position) {
        LayoutInflater inflater = LayoutInflater.from(activity);
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity);

        View view = inflater.inflate(R.layout.dialog_commande_activity_edit_prix, null);

        final EditText inputField = view.findViewById(R.id.dialog_edit_prix_produit_commande);

        builder.setView(view);

        // add "add" button
        builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int id) {
                TextView date, num, prixTotal, nom;
                if (!inputField.getText().toString().equals("") && !CommandesActivity.filtreRechercheEnCours) {
                    final String input = inputField.getText().toString();
                    if (Double.parseDouble(inputField.getText().toString()) > 0.0) {
                        //Changer le prix
                        currentCommande.getListeProduit().get(position).setPrixPromo(Float.parseFloat(input));
                        currentCommande.getListeProduit().get(position).setSiPromo(1);
                    } else {
                        currentCommande.getListeProduit().get(position).setPrixPromo(0.00);
                        currentCommande.getListeProduit().get(position).setSiPromo(0);
                    }
                    //Mise à jour de la quantité
                    DecimalFormat df = new DecimalFormat("0.00");
                    df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
                    df.setMinimumFractionDigits(2);
                    df.setDecimalSeparatorAlwaysShown(true);
                    df.setRoundingMode(RoundingMode.HALF_UP);
                    //CommandesActivity.prixLivraison.setText(""+df.format(currentCommande.getPrixLivraison())+"€");
                    CommandesActivity.appliquerPrixLivraison();
                    CommandesActivity.prixTotal.setText(""+df.format(currentCommande.getPrixTotal())+"€");
                    if (currentCommande.getQtetotal() > 1) {
                        CommandesActivity.qteTotal.setText("" + (currentCommande.getQtetotal()) + "pcs");
                    } else {
                        CommandesActivity.qteTotal.setText("" + (currentCommande.getQtetotal()) + "pc");
                    }

                    CommandesActivity.poidsTotal.setText(currentCommande.getPoidsTotalTxt());
                    CommandesActivity.mAdapter.notifyDataSetChanged();
                    //Fermer le clavier
                    InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
                }
            }
        });

        // add cancel button
        builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
            // listen for click on cancel button
            public void onClick(DialogInterface arg0, int arg1) {
                // Fermer le clavier
                InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
            }
        });

        // display add dialog
        builder.show();

        //Ouvrir le clavier
        InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.toggleSoftInput(InputMethodManager.SHOW_FORCED, InputMethodManager.HIDE_IMPLICIT_ONLY);

    }

}
