package fr.itsee.zelyx;

import static java.lang.Double.parseDouble;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static fr.itsee.zelyx.CommandesActivity.commandeAImprimer;
import static fr.itsee.zelyx.CommandesActivity.dernierTypeTicket;

public class DialogCommandesActivityListCommandesJour {

    static Activity mActivity;
    private static String code128;

    public static void show(final Activity activity, final int position) {
        mActivity = activity;

        LayoutInflater inflater = LayoutInflater.from(activity);
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        View view = inflater.inflate(R.layout.dialog_commandes_activity_liste_commande, null);

        final Spinner inputField = view.findViewById(R.id.dialog_edit_num_commande);
        final EditText numCommandeSaisie = view.findViewById(R.id.editNumeroCommande);

        builder.setView(view);

        final String BASE_URL = MainActivity.backOfficeURL;
        ArrayList<String> arrayNumeroCommandes = new ArrayList<>();
        Spinner spinnerListeNumeroCommandes = view.findViewById(R.id.dialog_edit_num_commande);

        arrayNumeroCommandes.add("--- Ce jour ---");

        ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<String>(
                activity, android.R.layout.simple_spinner_item);
        spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

            spinnerArrayAdapter.add(arrayNumeroCommandes.get(0));
            spinnerArrayAdapter.notifyDataSetChanged();
        spinnerListeNumeroCommandes.setAdapter(spinnerArrayAdapter);

        //Rafraîchir la liste déroulante des marques
        HttpJsonParser httpJsonParser = new HttpJsonParser();
        JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                BASE_URL + "listeNumeroCommandesJour.php", "GET", null);
        try {
            int success = jsonObject.getInt("success");
            JSONArray listeNumeroCommandesJourArray;
            if (success == 1) {
                listeNumeroCommandesJourArray = jsonObject.getJSONArray("data");
                //String[] arrayNumeroCommandes = new String[listeNumeroCommandesJourArray.length() + 1];

                for (int i = 0; i < listeNumeroCommandesJourArray.length(); i++) {

                    JSONObject jsonobject = listeNumeroCommandesJourArray.getJSONObject(i);

                    try {
                        arrayNumeroCommandes.add(jsonobject.getString("numeroCommande")+" "+jsonobject.getString("nomClient"));
                    } catch (Exception e) {
                        e.printStackTrace();
                        Toast.makeText(activity, "Erreur lors de la récupération de la liste des commandes du jour", Toast.LENGTH_SHORT).show();
                    }
                }

                for (int i = 1; i < arrayNumeroCommandes.size(); i++) {
                    spinnerArrayAdapter.add(arrayNumeroCommandes.get(i));
                    spinnerArrayAdapter.notifyDataSetChanged();
                }
                spinnerListeNumeroCommandes.setAdapter(spinnerArrayAdapter);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }

        // add "add" button
        builder.setPositiveButton("Imprimer", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int id) {
                String num_commande_a_imprimer = "";
                if (numCommandeSaisie.getText().toString() != "" && numCommandeSaisie.getText().toString().length() > 8) {
                    num_commande_a_imprimer = numCommandeSaisie.getText().toString().substring(0, 9);
                } else if (inputField != null) {
                    if (inputField.getSelectedItem().toString() != "" && inputField.getSelectedItem().toString().length() > 8 && inputField.getSelectedItem().toString() != "--- Ce jour ---") {
                            num_commande_a_imprimer = inputField.getSelectedItem().toString().substring(0, 9);
                    }
                }

                if (num_commande_a_imprimer != "") {
                    try {
                        //Récupérer les informations de la commande
                        final String BASE_URL = MainActivity.backOfficeURL;

                        int success;
                        HttpJsonParser httpJsonParser = new HttpJsonParser();
                        Map<String, String> httpParams = new HashMap<>();
                        httpParams.put("numero_commande", num_commande_a_imprimer);

                        JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                                BASE_URL + "getCommande.php", "GET", httpParams);
                        try {
                            success = jsonObject.getInt("success");

                            if (success == 1) {
                                JSONArray commandeArray = jsonObject.getJSONArray("data");
                                JSONObject commande = commandeArray.getJSONObject(0);
                                try {
                                    commandeAImprimer = new Commande();

                                    //Partie commande
                                    //parcel.writeString(num);
                                    commandeAImprimer.setNum(commande.getString("numero_commande"));
                                    //parcel.writeString(nomClient);
                                    commandeAImprimer.setNomClient(commande.getString("nom_entreprise"));
                                    //parcel.writeString(date);
                                    commandeAImprimer.setDate(commande.getString("date_commande"));
                                    //parcel.writeInt(qtetotal);
                                    //A PRECISER
                                    //CommandesActivity.commandeAImprimer.setQtetotal(commande.getInt("total_produits"));
                                    //parcel.writeDouble(prixTotal);
                                    commandeAImprimer.setPrixTotal(parseDouble(commande.getString("total_produits")));
                                    //parcel.writeList(listeProduit);

                                    //parcel.writeDouble(remiseGlobale);
                                    //Calculer à partir du total (totalremise*totalProduit/remiseGlobale)*100 pour indiquer en poucentage
                                    Double totalRemise = parseDouble(commande.getString("remise_globale"));
                                    Double totalProduit = parseDouble(commande.getString("total_produits"));
                                    commandeAImprimer.setRemiseGlobalePourcentage((totalRemise/totalProduit)*100);

                                    commandeAImprimer.setId_operateur(commande.getString("id_operateur"));
                                    //parcel.writeDouble(prixLivraison);
                                    commandeAImprimer.setPrixLivraison(parseDouble(commande.getString("total_fdp_ht")));
                                    //parcel.writeDouble(poidsTotal);
//                    parcel.writeInt(idTransporteur);
                                    commandeAImprimer.setIdTransporteur(commande.getInt("id_transporteur"));
                                    //parcel.writeInt(idPaysClient);
                                    commandeAImprimer.setIdPaysClient(commande.getInt("id_pays_client"));
                                    //parcel.writeString(codePostalClient);
                                    commandeAImprimer.setCodePostalClient(commande.getString("cp_client"));
                                    //parcel.writeString(nomTransporteur);
                                    commandeAImprimer.setNomTransporteur(commande.getString("mode_livraison"));

                                    /*commandeAImprimer.setNum(commande.getString("numero_commande"));
                                    commandeAImprimer.setNomClient(commande.getString("nom_client"));
                                    commandeAImprimer.setDate(commande.getString("date_commande"));
                                    commandeAImprimer.setNomTransporteur(commande.getString("mode_livraison"));
                                    commandeAImprimer.setRemiseGlobalePourcentage(commande.getDouble("remise_globale"));*/
                                } catch (Exception e) {
                                    Toast.makeText(activity, "Erreur de la récupération de la commande", Toast.LENGTH_SHORT).show();
                                    e.printStackTrace();
                                }

                                //recuperation des produits de la commande
                                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                                Map<String, String> httpParams2 = new HashMap<>();
                                httpParams2.put("num_commande", commande.getString("numero_commande"));
                                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                        BASE_URL + "listeProduitsCommande.php", "GET", httpParams2);

                                List<Produit> produitList = new ArrayList<>();

                                try {
                                    int success2 = jsonObject2.getInt("success");
                                    JSONArray produits;
                                    if (success2 == 1) {
                                        produits = jsonObject2.getJSONArray("data");
                                        //Iterate through the response and populate produits list
                                        for (int i = 0; i < produits.length(); i++) {
                                            Produit p = new Produit();
                                            JSONObject produit = produits.getJSONObject(i);
                                            try {
                                                p.setRef(produit.getString("reference"));
                                                p.setColoris(produit.getString("coloris"));
                                                p.setCommandable(produit.getString("commandable"));
                                                p.setCode128(produit.getString("code_128"));
                                                p.setQuantite_pack(produit.getInt("quantite_packs"));
                                                p.setPrix(produit.getDouble("prix"));
                                                p.setStock(produit.getInt("stock"));
                                                p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                                p.setInformations(produit.getString("informations"));
                                                p.setLien_image(produit.getString("lien_image"));
                                                p.setActif(produit.getInt("actif"));
                                                p.setQte(produit.getInt("quantite"));
                                                p.setPrixCatalogue(produit.getDouble("prix_catalogue"));
                                                p.setNbrScanner(0);
                                                produitList.add(p);
                                            } catch (Exception e) {
                                                e.printStackTrace();
                                            }
                                        }
                                        CommandesActivity.commandeAImprimer.setListeProduit(produitList);
                                    }
                                } catch (JSONException e) {
                                    e.printStackTrace();
                                }

                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                        //Afficher la boite de dialogue de choix du ticket
                        new AlertDialog.Builder(activity)
                                .setIcon(android.R.drawable.ic_dialog_alert)
                                .setTitle("Confirmation")
                                .setMessage("Quel type de ticket souhaitez-vous imprimer ?")
                                .setPositiveButton("Détaillé", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        dernierTypeTicket = "détaillé";
                                        Intent intent = new Intent(mActivity, TicketActivity.class);
                                        numCommandeSaisie.setText("");
                                        mActivity.startActivityForResult(intent, 7);
                                        mActivity.overridePendingTransition(0, 0);
                                    }

                                })
                                .setNegativeButton("Rassemblé", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                        dernierTypeTicket = "rassemblé";
                                        Intent intent = new Intent(mActivity, TicketActivity.class);
                                        numCommandeSaisie.setText("");
                                        mActivity.startActivityForResult(intent, 7);
                                        mActivity.overridePendingTransition(0, 0);
                                    }

                                })
                                .show();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }

                } else {
                    //Dialog erreur de saisie
                    new AlertDialog.Builder(activity)
                            .setIcon(android.R.drawable.ic_dialog_alert)
                            .setTitle("Numéro de commande incorrect!")
                            .setMessage("Veuillez choisir ou saisir un numéro de commande à 9 chiffres!")
                            .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                }
                            })
                            .show();
                }
            }
        });

        // add cancel button
        builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
            // listen for click on cancel button
            public void onClick(DialogInterface arg0, int arg1) {
            }
        });

        // display add dialog
        builder.show();

    }

}