package fr.itsee.zelyx;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

    public class DialogControleActivityListCommandes {

        static Activity mActivity;
        private static String code128;

        public static void show(final Activity activity, final int position) {
            mActivity = activity;

            LayoutInflater inflater = LayoutInflater.from(activity);
            final AlertDialog.Builder builder = new AlertDialog.Builder(activity);
            View view = inflater.inflate(R.layout.dialog_controle_activity_liste_commandes, null);

            final Spinner inputField = view.findViewById(R.id.dialog_edit_num_commande);
            final EditText numCommandeSaisie = view.findViewById(R.id.editNumeroCommande);

            builder.setView(view);

            final String BASE_URL = MainActivity.backOfficeURL;
            ArrayList<String> arrayNumeroCommandes = new ArrayList<>();

            //Rafraîchir la liste déroulante des marques
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeNumeroCommandesAControler.php", "GET", null);
            try {
                int success = jsonObject.getInt("success");
                JSONArray listeNumeroCommandesJourArray;
                if (success == 1) {
                    listeNumeroCommandesJourArray = jsonObject.getJSONArray("data");
                    arrayNumeroCommandes.add("--- Choix ---");
                    for (int i = 0; i < listeNumeroCommandesJourArray.length(); i++) {
                        JSONObject jsonobject = listeNumeroCommandesJourArray.getJSONObject(i);
                        try {
                            arrayNumeroCommandes.add(jsonobject.getString("numeroCommande"));
                        } catch (Exception e) {
                            e.printStackTrace();
                        }
                    }

                    ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<String>(
                            activity, android.R.layout.simple_spinner_item);
                    spinnerArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

                    Spinner spinnerListeNumeroCommandes = view.findViewById(R.id.dialog_edit_num_commande);
                    for (int i = 0; i < arrayNumeroCommandes.size(); i++) {
                        spinnerArrayAdapter.add(arrayNumeroCommandes.get(i) + "\n");
                        spinnerArrayAdapter.notifyDataSetChanged();
                    }
                    spinnerListeNumeroCommandes.setAdapter(spinnerArrayAdapter);
                }
            } catch (JSONException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }

            // add "add" button
            builder.setPositiveButton("Choisir", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int id) {
                    String num_commande_a_imprimer = "";
                    if (numCommandeSaisie.getText().toString() != "" && numCommandeSaisie.getText().toString().length() > 8 && numCommandeSaisie.getText().toString().substring(0, 1) == "2") {
                        num_commande_a_imprimer = numCommandeSaisie.getText().toString().substring(0, 9);
                    } else if (inputField.getSelectedItem().toString() != "--- Choix ---" && inputField.getSelectedItem().toString().length() > 8 && inputField.getSelectedItem().toString().substring(0, 1) == "2") {
                        num_commande_a_imprimer = inputField.getSelectedItem().toString().substring(0, 9);
                    } else {
                        num_commande_a_imprimer = "";
                    }
                    if (num_commande_a_imprimer != "") {
                        try {
                            //Récupérer les informations de la commande
                            final String BASE_URL = MainActivity.backOfficeURL;

                            int success;
                            HttpJsonParser httpJsonParser = new HttpJsonParser();
                            Map<String, String> httpParams = new HashMap<>();
                            httpParams.put("numero_commande", num_commande_a_imprimer);

                            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                                    BASE_URL + "getCommande.php", "GET", httpParams);
                            try {
                                success = jsonObject.getInt("success");

                                if (success == 1) {
                                    JSONArray commandeArray = jsonObject.getJSONArray("data");
                                    JSONObject commande = commandeArray.getJSONObject(0);
                                    try {
                                       /* currentControle = new Commande();
                                        currentControle.setNum(commande.getString("numero_commande"));
                                        currentControle.setNomClient(commande.getString("nom_client"));
                                        currentControle.setDate(commande.getString("date_commande"));
                                        currentControle.setModeLivraison(commande.getString("mode_livraison"));
                                        currentControle.setRemiseGlobalePourcentage(commande.getDouble("remise_globale"));*/
                                    } catch (Exception e) {
                                        Toast.makeText(activity, "Erreur de la récupération de la commande", Toast.LENGTH_SHORT).show();
                                        e.printStackTrace();
                                    }

                                    //recuperation des produits de la commande
                                    HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                                    Map<String, String> httpParams2 = new HashMap<>();
                                    httpParams2.put("num_commande", num_commande_a_imprimer);
                                    JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                            BASE_URL + "listeProduitsCommande.php", "GET", httpParams2);

                                    List<Produit> produitList = new ArrayList<>();

                                    try {
                                        int success2 = jsonObject2.getInt("success");
                                        JSONArray produits;
                                        if (success2 == 1) {
                                            /*produits = jsonObject2.getJSONArray("data");
                                            for (int i = 0; i < produits.length(); i++) {
                                                Produit p = new Produit();
                                                JSONObject produit = produits.getJSONObject(i);

                                                try {
                                                    p.setRef(produit.getString("reference"));
                                                    p.setColoris(produit.getString("coloris"));
                                                    p.setCommandable(produit.getString("commandable"));
                                                    p.setCode128(produit.getString("code_128"));
                                                    p.setQuantite_pack(produit.getInt("quantite_packs"));
                                                    p.setPrix(produit.getDouble("prix"));
                                                    p.setStock(produit.getInt("stock"));
                                                    p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                                    p.setInformations(produit.getString("informations"));
                                                    p.setLien_image(produit.getString("lien_image"));
                                                    p.setActif(produit.getInt("actif"));
                                                    p.setQte(produit.getInt("quantite"));
                                                    p.setPrixCatalogue(produit.getDouble("prix_catalogue"));
                                                    p.setNbrScanner(0);
                                                    produitList.add(p);
                                                } catch (Exception e) {
                                                    e.printStackTrace();
                                                }
                                            }*/

                                           // currentControle.setListeProduit(produitList);
                                        }
                                    } catch (JSONException e) {
                                        e.printStackTrace();
                                    }

                                }
                            } catch (JSONException e) {
                                e.printStackTrace();
                            }


                        } catch (Exception e) {
                            e.printStackTrace();
                        }

                    } else {
                        //Dialog erreur de saisie
                        new AlertDialog.Builder(activity)
                                .setIcon(android.R.drawable.ic_dialog_alert)
                                .setTitle("Numéro de commande")
                                .setMessage("Veuillez choisir ou saisir un numéro de commande à 9 chiffres!")
                                .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
                                    @Override
                                    public void onClick(DialogInterface dialog, int which) {
                                    }
                                })
                                .show();
                    }
                }
            });

            builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface arg0, int arg1) {
                }
            });

            builder.show();

        }

}
