package fr.itsee.zelyx;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.LayoutInflater;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.TextView;

import java.text.DecimalFormat;

import static fr.itsee.zelyx.CommandesActivity.currentCommande;

public class DialogRemiseGlobaleActivityEditRemise {

    public static void show(final Activity activity, final int position) {
        LayoutInflater inflater = LayoutInflater.from(activity);
        final AlertDialog.Builder builder = new AlertDialog.Builder(activity);

        View view = inflater.inflate(R.layout.dialog_commande_activity_remise_globale, null);

        final EditText inputField = view.findViewById(R.id.dialog_edit_remise_globale_commande);

        builder.setView(view);

        // add "add" button
        builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int id) {
                TextView date, num, prixTotal, nom;
                if (!inputField.getText().toString().equals("") && !CommandesActivity.filtreRechercheEnCours) {
                    if (Integer.parseInt(inputField.getText().toString()) > -1) {
                        DecimalFormat df = new DecimalFormat("0.00");
                        df.setMaximumFractionDigits(2);//arrondi à 2 chiffres après la virgule
                        df.setMinimumFractionDigits(2);
                        df.setDecimalSeparatorAlwaysShown(true);
                        final String input = inputField.getText().toString();
                        //Mise à jour de la quantité
                        //currentCommande.getListeProduit().get(position);
                        //Qte unitaire
                        if (Double.parseDouble(input) == 0.0) {
                            currentCommande.setRemiseGlobalePourcentage(0.0);
                            CommandesActivity.remiseGlobaleTotal.setText("-0€");
                            CommandesActivity.textRemiseGlobale.setText("Remise (0%): ");
                            CommandesActivity.remiseGlobaleLigne.setVisibility(View.INVISIBLE);
                        } else {
                            CommandesActivity.remiseGlobaleLigne.setVisibility(View.VISIBLE);
                            currentCommande.setRemiseGlobalePourcentage(Double.parseDouble(input));
                            CommandesActivity.remiseGlobaleTotal.setText("-"+df.format((currentCommande.getPrixTotal()*Double.parseDouble(input))/100)+"€");
                            CommandesActivity.textRemiseGlobale.setText("Remise ("+Double.parseDouble(input)+"%): ");
                        }
                        CommandesActivity.prixTotal.setText(""+df.format(currentCommande.getPrixTotal()+currentCommande.getRemiseTotal())+"€");

                        if (currentCommande.getQtetotal() > 1) {
                            CommandesActivity.qteTotal.setText("" + (currentCommande.getQtetotal()) + "pcs");
                        } else {
                            CommandesActivity.qteTotal.setText("" + (currentCommande.getQtetotal()) + "pc");
                        }

                        CommandesActivity.mAdapter.notifyDataSetChanged();
                        //new CommandesActivity.UpdateCommandeAsyncTask().execute();
                        //Fermer le clavier
                        InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
                        imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
                    }
                }
            }
        });

        // add cancel button
        builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
            // listen for click on cancel button
            public void onClick(DialogInterface arg0, int arg1) {
                // Fermer le clavier
                InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.toggleSoftInput(InputMethodManager.HIDE_IMPLICIT_ONLY, 0);
            }
        });

        // display add dialog
        builder.show();

        //Ouvrir le clavier
        InputMethodManager imm = (InputMethodManager) activity.getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.toggleSoftInput(InputMethodManager.SHOW_FORCED, InputMethodManager.HIDE_IMPLICIT_ONLY);

    }

}
