package fr.itsee.zelyx;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;

import android.provider.Settings;
import android.support.v7.app.AppCompatActivity;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class IdentificationActivity extends AppCompatActivity {

    @Override
    public void onBackPressed() {
      //Rien
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_identification);

            if (android.provider.Settings.System.getInt(getContentResolver(),
                    Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
            } else {
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
            }

        final EditText codeVendeur = findViewById(R.id.codeVendeur);

        codeVendeur.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
                if (!codeVendeur.getText().toString().isEmpty() && codeVendeur.getText().toString().length() == 4) {
                    MainActivity.code_vendeur = codeVendeur.getText().toString();
                }
            }

            @Override
            public void afterTextChanged(Editable editable) {
                if (isOnline()) {
                    if (MainActivity.code_vendeur != null && !MainActivity.code_vendeur.isEmpty() && MainActivity.code_vendeur.length() == 4) {
                        new ControleAcces().execute();
                    }
                } else {
                    Intent intent = new Intent(getApplicationContext(), HorsLigneActivity.class);
                    startActivity(intent);
                    overridePendingTransition(0, 0);
                }
            }
        });

        //Activtion du scanner au premier lancement 5 secondes après (temps de recherche des scanners disponibles)

    }

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

    }

    @Override
    protected void onResume() {
        super.onResume();

        if (android.provider.Settings.System.getInt(getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }
    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    @Override
    protected void onPause() {
        super.onPause();
        this.overridePendingTransition(0, 0);
    }

    @Override
    protected void onRestart() {
        super.onRestart();
    }

    //Masquer le clavier quand on appuie en dehors du champ
    @Override
    public boolean dispatchTouchEvent(MotionEvent ev) {
        if (getCurrentFocus() != null) {
            InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);
        }
        return super.dispatchTouchEvent(ev);
    }

    private class ControleAcces extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private Integer success = 0;

        @Override
        protected String doInBackground(String... params) {
            if (MainActivity.code_vendeur.length() == 4) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();

                httpParams.put("code_vendeur", MainActivity.code_vendeur);
                try {
                    JSONObject jsonObject2 = httpJsonParser.makeHttpRequest(
                            BASE_URL + "checkAccess.php", "GET", httpParams);

                    try {
                        JSONArray jsonUtilisateur;
                        success = jsonObject2.getInt("success");
                        if (success == 1) {
                            jsonUtilisateur = jsonObject2.getJSONArray("data");
                            JSONObject RetourUtilisateur = jsonUtilisateur.getJSONObject(0);

                            MainActivity.initiales_vendeur = RetourUtilisateur.getString("nom").substring(0, 1).toUpperCase() + RetourUtilisateur.getString("prenom").substring(0, 1).toUpperCase();
                            MainActivity.code_boutique = RetourUtilisateur.getString("code_boutique");
                            MainActivity.mac_imprimante = RetourUtilisateur.getString("mac_imprimante");
                            MainActivity.id_operateur = RetourUtilisateur.getString("id");
                        }
                    } catch (JSONException e) {
                        success = 0;
                        return null;
                    }
                } catch (Exception e) {
                    success = 0;
                    return null;
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            if (success == 1) {
                //Accès à l'application
                Intent intent = new Intent(IdentificationActivity.this, MainActivity.class);
                startActivityForResult(intent, 0);
                overridePendingTransition(0, 0);
                finish();
            }
            super.onPostExecute(s);
        }
    }

}
